
function setup(doc) {
    var mode = '';
    var paths = [];
    var initXY = [];
    var z=0;
    var stage = document.getElementById("index_hype_container");
    var SceneScale= getScale();
    function is_touch_device() {
        try {
            document.createEvent("TouchEvent");
            return true
        } catch (e) {
            return false
        }
    };


    var scene = document.getElementsByClassName("HYPE_scene")[doc.sceneNames().indexOf(doc.currentSceneName())];
    var params;
    var selected;

    if (!is_touch_device()) {
        stage.addEventListener("mousedown", mouseDown, false);
        stage.addEventListener("mousemove", mouseMove, false);
        stage.addEventListener("mouseup", mouseEnd, false);
        stage.addEventListener("mouseleave", mouseEnd, false);
    } else {
        stage.addEventListener("touchstart", mouseDown, false);
        stage.addEventListener("touchmove", mouseMove, false);
        stage.addEventListener("touchend", mouseEnd, false);
    }


    function mouseDown(event) {
      console.log(drawstage)
        event.preventDefault();
        scene.tap = true;
        selected = document.elementFromPoint(getXY(event)[0], getXY(event)[1]);
        if (selected.className != "HYPE_element controller" && selected.className != "HYPE_scene") {

            params = selected.attributes.getNamedItem("alt");
            params != null ? selected.params = eval("({" + params.value + "})") : selected.params = "";

        } else {
            selected = "";
        }
        switch (selected.id) {
          case "pencil":
              mode = selected.id;
              break;
              case "shape":
                  mode = selected.id;
              break;
              case "clear":
                  mode = selected.id;
              break;
              case "selecter":
                  mode = selected.id;
              break;
        }
        selected.drawit = new drawer('segment');
        initXY = [(getXY(event)[0] / SceneScale - stage.offsetLeft),(getXY(event)[1] / SceneScale - stage.offsetTop)]

    }

    function mouseMove(event) {
        event.preventDefault();
        //for android scalling
        var scaleW, scaleH;
        if (is_touch_device()) {
            var selID = document.elementFromPoint(arguments[0].touches[0].clientX, arguments[0].touches[0].clientY);
            if (selID.id.length == 0) {
                mouseEnd();
            }
        } else {
        }
        if (scene.tap) {
            leftPos = getXY(event)[0] / SceneScale - stage.offsetLeft;
            topPos = getXY(event)[1] / SceneScale- stage.offsetTop;

            selected.drawit.draw(leftPos, topPos);



        }
    }

    function mouseEnd(event) {
        event.preventDefault();
        if (scene.tap) {
            scene.tap = false;


            selected.drawit.flatten();
        }
    }

    var drawer = function(object) {

        this.object = object;
        switch (mode) {
          case "pencil":
              object = new Path();
              object.strokeColor = 'black';
              paths.push(object)
          break;
          case "shape":
              object = new Path();
              object.strokeColor = 'black';
              object.closed = true;
              object.fillColor = 'red';
            object.fillColor.hue = Math.random() * 360;
          paths.push(object)
          break;
          case "clear":
              for(i=0;i<paths.length;i++){
              paths[i].remove();
          }  break;


        }
  var xDif,yDif;
        this.draw = function(x, y) {
            switch (mode) {
                case "pencil":
                    object.add(new Point(x, y));
                    break;
                case "shape":
                    object.add(new Point(x, y));
                    break;
                    case "selecter":

                    var hitResult = project.hitTest([x,y]);
                    if(hitResult!='null'){
                    if( z==0){
                      xDif = hitResult.item.position.x-initXY[0];
                      yDif = hitResult.item.position.y-initXY[1];
                      z=1;
                    }
                    hitResult.item.position=[x+xDif,y+yDif]
                  //  hitResult.item.fillColor.hue += 1;
                  }
                    break;
                }

        }

        this.flatten = function() {
            switch (mode) {
                case "pencil":
                    object.flatten(10);
                    break;
                case "shape":
                  object.flatten(40);
                  object.smooth();
            }
            z=0;
            //console.log(paths)
        }

    }
    var hitOptions = {
	segments: true,
	stroke: true,
	fill: true,
	tolerance: 5
};
function getXY(event) {
    var xLoc, yLoc;

    if (!event.touches) {
        xLoc = event.clientX;
        yLoc = event.clientY;
    } else {
        xLoc = event.touches[0].clientX;
        yLoc = event.touches[0].clientY;
    }
    return [xLoc, yLoc];

}
function getScale(){

  var w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
  if (is_touch_device()) {
      scale = w / parseInt(stage.style.width);
  } else {
      scale = 1;
  }
  return scale;

}

}
